import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class pesciolini_quasi_intelligenti extends PApplet {//Semi Intelligent fishes simulation
//Marco Zamarato
//Venice 13/02/2007



// Declare the object Fish and the number of fishes
Fish[] a;
int numFishes = 7;



public void setup() {
 size(400,250);
 smooth();
 noStroke();
frameRate(24);


// Create the fishes by calling the Fish class
a = new Fish[numFishes];
int i;
for (i=0; i<numFishes; i++) {
// Creating random data for fishes positions and speeds
 a[i] = new Fish(floor(random(0,width)),floor(random(0,height)),random(0.5f,2.5f),random(0.5f,2.5f), floor(random(130,150)), floor(random(120,150)), floor(random(100,160)));
}
}

public void draw() {
 background(10,5,45);
 
int i;
for (i=0; i<numFishes; i++) {
 a[i].draw();
 
  int u;
 for (u=0; u<numFishes-1; u++) {

// Trying somehow to make the fishes a bit smart .. they should avoid collisions
   if (a[u].xpos-30 < a[u+1].xpos && a[u+1].xpos+30 < a[u].xpos || a[u].ypos-30 < a[u+1].ypos && a[u+1].ypos < a[u].ypos+30 ||
   a[u].xpos-10 < a[u+1].xpos && a[u+1].xpos+10 < a[u].xpos || a[u].ypos-10 < a[u+1].ypos && a[u+1].ypos < a[u].ypos+10) {
     a[u].xdirection *= -1;
   }
     
 }
}
}


// Starting the Fish class
class Fish {
  
int col1, col2, col3;

float xpos, ypos; 

float xspeed = 2.2f;  // Speed of the shape
float yspeed = 1.8f;  // Speed of the shape

int xdirection = 1;  // Left or Right
int ydirection = 1;  // Top to Bottom

int num = 30;
float mx[] = new float[num];
float my[] = new float[num];

Fish(int q, int w, float e, float r, int t, int y, int u) {
 xpos = q;
 ypos = w;
 xspeed = e;
 yspeed = r;
 col1=t;
 col2=y;
 col3=u;
}

public void draw() 
{
  // Reads throught the entire array
  // and shifts the values to the left
  for(int i=1; i<num; i++) {
    mx[i-1] = mx[i];
    my[i-1] = my[i];
  } 
  // Add the new values to the end of the array
  mx[num-1] = xpos;
  my[num-1] = ypos;
  

  xpos = xpos + ( xspeed * xdirection );
  ypos = ypos + ( yspeed * ydirection );
  
  // Test to see if the shape exceeds the boundaries of the screen
  // If it does, reverse its direction by multiplying by -1
  
  if (xpos > width || xpos < 0) {
    xdirection *= -1;
  }
  if (ypos > height || ypos < 0) {
    ydirection *= -1;
  }
 
  for(int i=0; i<num; i++) {
    fill (col1, col2, col3, 23);
    //fill (140,132,240,23);
    ellipse(mx[i], my[i], i/2.1f, i/2);
  }
}
}
static public void main(String args[]) {   PApplet.main(new String[] { "pesciolini_quasi_intelligenti" });}}